package lor;
import rwth.i2.ltlrv.LTL;

/*
 * This is a simplified version of the lock-order-reversal example.
 * Thread IDs and lock IDs are simulated by integers.
 * The same could be achieved in a similar manner with real locks and threads.
 */

public class Main {

	/*
	 * Formula specifying a lock-order-reversal.
	 */
    @LTL("Integer i, Integer j, Integer x, Integer y:\n" +
    		"\n" +
    		"\n" +
    		"G(\n" +
    		"	(\n" +
    		"		!(\n" +
    		"			entry(call(static void lor.Main.lock(..)) && args (i,x))\n" +
    		"		)\n" +
    		"	) U (\n" +
    		"		(\n" +
    		"			entry(call(static void lor.Main.lock(..)) && args (i,x))\n" +
    		"		) && (\n" +
    		"			X(		\n" +
    		"				(\n" +
    		"					(\n" +
    		"						!(\n" +
    		"							entry(call(static void lor.Main.unlock(..)) && args (i,y))\n" +
    		"						)\n" +
    		"					) U (\n" +
    		"						entry(call(static void lor.Main.lock(..)) && args (i,y) && if(x!=y))\n" +
    		"					)\n" +
    		"				) -> (\n" +
    		"					G(\n" +
    		"						! (\n" +
    		"							(\n" +
    		"								!(\n" +
    		"									entry(call(static void lor.Main.lock(..)) && args (j,y))\n" +
    		"								)\n" +
    		"							) U (\n" +
    		"								(\n" +
    		"									entry(call(static void lor.Main.lock(..)) && args (j,y) && if(j!=i))\n" +
    		"								) && (\n" +
    		"									X(\n" +
    		"										(\n" +
    		"											!(\n" +
    		"												entry(call(static void lor.Main.unlock(..)) && args (j,x))\n" +
    		"											)\n" +
    		"										) U (\n" +
    		"											entry(call(static void lor.Main.lock(..)) && args (j,x) && if(j!=i))\n" +
    		"										)\n" +
    		"									)\n" +
    		"								)\n" +
    		"							)\n" +
    		"						)\n" +
    		"					)\n" +
    		"				)\n" +
    		"			)\n" +
    		"		)\n" +
    		"	)\n" +
    		")\n" +
    		"")

    //two arbitrary different constants
    final static Integer i1 = new Integer(1);
    final static Integer i2 = new Integer(2);

    /**
     * @param args
     */
    public static void main(String[] args) {
        System.err.println("THREAD #1 LOCKS #1");
    	lock(i1,i1);
        System.err.println("THREAD #1 UNLOCKS #1");
        unlock(i1,i1);
        System.err.println("THREAD #1 LOCKS #1");
    	lock(i1,i1);
        System.err.println("THREAD #2 LOCKS #2");
        lock(i2,i2);
        System.err.println("THREAD #1 LOCKS #2");
        lock(i1,i2);
        System.err.println("THREAD #2 LOCKS #1 (LOR occurs - normally the system would halt now)");
        lock(i2,i1);
        System.err.println("SHUTDOWN");
    }

    static void unlock(Integer i12, Integer i22) {
    }

    static void lock(Integer i12, Integer i13) {
    }

}
